#ifndef _H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints_DCPS_H_
#define _H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FollowWaypoints_.h"


namespace nav2_msgs
{
    namespace action
    {
        namespace dds_
        {
            class FollowWaypoints_Goal_TypeSupportInterface;

            typedef FollowWaypoints_Goal_TypeSupportInterface * FollowWaypoints_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Goal_TypeSupportInterface> FollowWaypoints_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Goal_TypeSupportInterface> FollowWaypoints_Goal_TypeSupportInterface_out;


            class FollowWaypoints_Goal_DataWriter;

            typedef FollowWaypoints_Goal_DataWriter * FollowWaypoints_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Goal_DataWriter> FollowWaypoints_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Goal_DataWriter> FollowWaypoints_Goal_DataWriter_out;


            class FollowWaypoints_Goal_DataReader;

            typedef FollowWaypoints_Goal_DataReader * FollowWaypoints_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Goal_DataReader> FollowWaypoints_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Goal_DataReader> FollowWaypoints_Goal_DataReader_out;


            class FollowWaypoints_Goal_DataReaderView;

            typedef FollowWaypoints_Goal_DataReaderView * FollowWaypoints_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Goal_DataReaderView> FollowWaypoints_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Goal_DataReaderView> FollowWaypoints_Goal_DataReaderView_out;

            struct FollowWaypoints_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FollowWaypoints_Goal_, struct FollowWaypoints_Goal_Seq_uniq_> FollowWaypoints_Goal_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_Goal_Seq> FollowWaypoints_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_Goal_Seq> FollowWaypoints_Goal_Seq_out;

            class  FollowWaypoints_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_Goal_TypeSupportInterface_var _var_type;

                static FollowWaypoints_Goal_TypeSupportInterface_ptr _duplicate (FollowWaypoints_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_Goal_TypeSupportInterface () {};
                ~FollowWaypoints_Goal_TypeSupportInterface () {};
            private:
                FollowWaypoints_Goal_TypeSupportInterface (const FollowWaypoints_Goal_TypeSupportInterface &);
                FollowWaypoints_Goal_TypeSupportInterface & operator = (const FollowWaypoints_Goal_TypeSupportInterface &);
            };

            class  FollowWaypoints_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_Goal_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_Goal_DataWriter_var _var_type;

                static FollowWaypoints_Goal_DataWriter_ptr _duplicate (FollowWaypoints_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Goal_& instance_data) = 0;

            protected:
                FollowWaypoints_Goal_DataWriter () {};
                ~FollowWaypoints_Goal_DataWriter () {};
            private:
                FollowWaypoints_Goal_DataWriter (const FollowWaypoints_Goal_DataWriter &);
                FollowWaypoints_Goal_DataWriter & operator = (const FollowWaypoints_Goal_DataWriter &);
            };

            class  FollowWaypoints_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_Goal_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_Goal_DataReader_var _var_type;

                static FollowWaypoints_Goal_DataReader_ptr _duplicate (FollowWaypoints_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Goal_& instance) = 0;

            protected:
                FollowWaypoints_Goal_DataReader () {};
                ~FollowWaypoints_Goal_DataReader () {};
            private:
                FollowWaypoints_Goal_DataReader (const FollowWaypoints_Goal_DataReader &);
                FollowWaypoints_Goal_DataReader & operator = (const FollowWaypoints_Goal_DataReader &);
            };

            class  FollowWaypoints_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_Goal_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_Goal_DataReaderView_var _var_type;

                static FollowWaypoints_Goal_DataReaderView_ptr _duplicate (FollowWaypoints_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Goal_& instance) = 0;

            protected:
                FollowWaypoints_Goal_DataReaderView () {};
                ~FollowWaypoints_Goal_DataReaderView () {};
            private:
                FollowWaypoints_Goal_DataReaderView (const FollowWaypoints_Goal_DataReaderView &);
                FollowWaypoints_Goal_DataReaderView & operator = (const FollowWaypoints_Goal_DataReaderView &);
            };
            class FollowWaypoints_SendGoal_Request_TypeSupportInterface;

            typedef FollowWaypoints_SendGoal_Request_TypeSupportInterface * FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Request_TypeSupportInterface> FollowWaypoints_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Request_TypeSupportInterface> FollowWaypoints_SendGoal_Request_TypeSupportInterface_out;


            class FollowWaypoints_SendGoal_Request_DataWriter;

            typedef FollowWaypoints_SendGoal_Request_DataWriter * FollowWaypoints_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Request_DataWriter> FollowWaypoints_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Request_DataWriter> FollowWaypoints_SendGoal_Request_DataWriter_out;


            class FollowWaypoints_SendGoal_Request_DataReader;

            typedef FollowWaypoints_SendGoal_Request_DataReader * FollowWaypoints_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Request_DataReader> FollowWaypoints_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Request_DataReader> FollowWaypoints_SendGoal_Request_DataReader_out;


            class FollowWaypoints_SendGoal_Request_DataReaderView;

            typedef FollowWaypoints_SendGoal_Request_DataReaderView * FollowWaypoints_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Request_DataReaderView> FollowWaypoints_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Request_DataReaderView> FollowWaypoints_SendGoal_Request_DataReaderView_out;

            struct FollowWaypoints_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FollowWaypoints_SendGoal_Request_, struct FollowWaypoints_SendGoal_Request_Seq_uniq_> FollowWaypoints_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_SendGoal_Request_Seq> FollowWaypoints_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_SendGoal_Request_Seq> FollowWaypoints_SendGoal_Request_Seq_out;

            class  FollowWaypoints_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Request_TypeSupportInterface_var _var_type;

                static FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _duplicate (FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_SendGoal_Request_TypeSupportInterface () {};
                ~FollowWaypoints_SendGoal_Request_TypeSupportInterface () {};
            private:
                FollowWaypoints_SendGoal_Request_TypeSupportInterface (const FollowWaypoints_SendGoal_Request_TypeSupportInterface &);
                FollowWaypoints_SendGoal_Request_TypeSupportInterface & operator = (const FollowWaypoints_SendGoal_Request_TypeSupportInterface &);
            };

            class  FollowWaypoints_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Request_DataWriter_var _var_type;

                static FollowWaypoints_SendGoal_Request_DataWriter_ptr _duplicate (FollowWaypoints_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_SendGoal_Request_& instance_data) = 0;

            protected:
                FollowWaypoints_SendGoal_Request_DataWriter () {};
                ~FollowWaypoints_SendGoal_Request_DataWriter () {};
            private:
                FollowWaypoints_SendGoal_Request_DataWriter (const FollowWaypoints_SendGoal_Request_DataWriter &);
                FollowWaypoints_SendGoal_Request_DataWriter & operator = (const FollowWaypoints_SendGoal_Request_DataWriter &);
            };

            class  FollowWaypoints_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Request_DataReader_var _var_type;

                static FollowWaypoints_SendGoal_Request_DataReader_ptr _duplicate (FollowWaypoints_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_SendGoal_Request_& instance) = 0;

            protected:
                FollowWaypoints_SendGoal_Request_DataReader () {};
                ~FollowWaypoints_SendGoal_Request_DataReader () {};
            private:
                FollowWaypoints_SendGoal_Request_DataReader (const FollowWaypoints_SendGoal_Request_DataReader &);
                FollowWaypoints_SendGoal_Request_DataReader & operator = (const FollowWaypoints_SendGoal_Request_DataReader &);
            };

            class  FollowWaypoints_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Request_DataReaderView_var _var_type;

                static FollowWaypoints_SendGoal_Request_DataReaderView_ptr _duplicate (FollowWaypoints_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_SendGoal_Request_& instance) = 0;

            protected:
                FollowWaypoints_SendGoal_Request_DataReaderView () {};
                ~FollowWaypoints_SendGoal_Request_DataReaderView () {};
            private:
                FollowWaypoints_SendGoal_Request_DataReaderView (const FollowWaypoints_SendGoal_Request_DataReaderView &);
                FollowWaypoints_SendGoal_Request_DataReaderView & operator = (const FollowWaypoints_SendGoal_Request_DataReaderView &);
            };
            class FollowWaypoints_SendGoal_Response_TypeSupportInterface;

            typedef FollowWaypoints_SendGoal_Response_TypeSupportInterface * FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Response_TypeSupportInterface> FollowWaypoints_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Response_TypeSupportInterface> FollowWaypoints_SendGoal_Response_TypeSupportInterface_out;


            class FollowWaypoints_SendGoal_Response_DataWriter;

            typedef FollowWaypoints_SendGoal_Response_DataWriter * FollowWaypoints_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Response_DataWriter> FollowWaypoints_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Response_DataWriter> FollowWaypoints_SendGoal_Response_DataWriter_out;


            class FollowWaypoints_SendGoal_Response_DataReader;

            typedef FollowWaypoints_SendGoal_Response_DataReader * FollowWaypoints_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Response_DataReader> FollowWaypoints_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Response_DataReader> FollowWaypoints_SendGoal_Response_DataReader_out;


            class FollowWaypoints_SendGoal_Response_DataReaderView;

            typedef FollowWaypoints_SendGoal_Response_DataReaderView * FollowWaypoints_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_SendGoal_Response_DataReaderView> FollowWaypoints_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_SendGoal_Response_DataReaderView> FollowWaypoints_SendGoal_Response_DataReaderView_out;

            struct FollowWaypoints_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < FollowWaypoints_SendGoal_Response_, struct FollowWaypoints_SendGoal_Response_Seq_uniq_> FollowWaypoints_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_SendGoal_Response_Seq> FollowWaypoints_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_SendGoal_Response_Seq> FollowWaypoints_SendGoal_Response_Seq_out;

            class  FollowWaypoints_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Response_TypeSupportInterface_var _var_type;

                static FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _duplicate (FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_SendGoal_Response_TypeSupportInterface () {};
                ~FollowWaypoints_SendGoal_Response_TypeSupportInterface () {};
            private:
                FollowWaypoints_SendGoal_Response_TypeSupportInterface (const FollowWaypoints_SendGoal_Response_TypeSupportInterface &);
                FollowWaypoints_SendGoal_Response_TypeSupportInterface & operator = (const FollowWaypoints_SendGoal_Response_TypeSupportInterface &);
            };

            class  FollowWaypoints_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Response_DataWriter_var _var_type;

                static FollowWaypoints_SendGoal_Response_DataWriter_ptr _duplicate (FollowWaypoints_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_SendGoal_Response_& instance_data) = 0;

            protected:
                FollowWaypoints_SendGoal_Response_DataWriter () {};
                ~FollowWaypoints_SendGoal_Response_DataWriter () {};
            private:
                FollowWaypoints_SendGoal_Response_DataWriter (const FollowWaypoints_SendGoal_Response_DataWriter &);
                FollowWaypoints_SendGoal_Response_DataWriter & operator = (const FollowWaypoints_SendGoal_Response_DataWriter &);
            };

            class  FollowWaypoints_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Response_DataReader_var _var_type;

                static FollowWaypoints_SendGoal_Response_DataReader_ptr _duplicate (FollowWaypoints_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_SendGoal_Response_& instance) = 0;

            protected:
                FollowWaypoints_SendGoal_Response_DataReader () {};
                ~FollowWaypoints_SendGoal_Response_DataReader () {};
            private:
                FollowWaypoints_SendGoal_Response_DataReader (const FollowWaypoints_SendGoal_Response_DataReader &);
                FollowWaypoints_SendGoal_Response_DataReader & operator = (const FollowWaypoints_SendGoal_Response_DataReader &);
            };

            class  FollowWaypoints_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_SendGoal_Response_DataReaderView_var _var_type;

                static FollowWaypoints_SendGoal_Response_DataReaderView_ptr _duplicate (FollowWaypoints_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_SendGoal_Response_& instance) = 0;

            protected:
                FollowWaypoints_SendGoal_Response_DataReaderView () {};
                ~FollowWaypoints_SendGoal_Response_DataReaderView () {};
            private:
                FollowWaypoints_SendGoal_Response_DataReaderView (const FollowWaypoints_SendGoal_Response_DataReaderView &);
                FollowWaypoints_SendGoal_Response_DataReaderView & operator = (const FollowWaypoints_SendGoal_Response_DataReaderView &);
            };
            class Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface;

            typedef Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface * Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface> Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface> Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_out;


            class Sample_FollowWaypoints_SendGoal_Request_DataWriter;

            typedef Sample_FollowWaypoints_SendGoal_Request_DataWriter * Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Request_DataWriter> Sample_FollowWaypoints_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Request_DataWriter> Sample_FollowWaypoints_SendGoal_Request_DataWriter_out;


            class Sample_FollowWaypoints_SendGoal_Request_DataReader;

            typedef Sample_FollowWaypoints_SendGoal_Request_DataReader * Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Request_DataReader> Sample_FollowWaypoints_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Request_DataReader> Sample_FollowWaypoints_SendGoal_Request_DataReader_out;


            class Sample_FollowWaypoints_SendGoal_Request_DataReaderView;

            typedef Sample_FollowWaypoints_SendGoal_Request_DataReaderView * Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Request_DataReaderView> Sample_FollowWaypoints_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Request_DataReaderView> Sample_FollowWaypoints_SendGoal_Request_DataReaderView_out;

            struct Sample_FollowWaypoints_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_FollowWaypoints_SendGoal_Request_, struct Sample_FollowWaypoints_SendGoal_Request_Seq_uniq_> Sample_FollowWaypoints_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_FollowWaypoints_SendGoal_Request_Seq> Sample_FollowWaypoints_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_FollowWaypoints_SendGoal_Request_Seq> Sample_FollowWaypoints_SendGoal_Request_Seq_out;

            class  Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface (const Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface &);
                Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface & operator = (const Sample_FollowWaypoints_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_FollowWaypoints_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Request_DataWriter_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_FollowWaypoints_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_FollowWaypoints_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_FollowWaypoints_SendGoal_Request_DataWriter () {};
                ~Sample_FollowWaypoints_SendGoal_Request_DataWriter () {};
            private:
                Sample_FollowWaypoints_SendGoal_Request_DataWriter (const Sample_FollowWaypoints_SendGoal_Request_DataWriter &);
                Sample_FollowWaypoints_SendGoal_Request_DataWriter & operator = (const Sample_FollowWaypoints_SendGoal_Request_DataWriter &);
            };

            class  Sample_FollowWaypoints_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Request_DataReader_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_SendGoal_Request_& instance) = 0;

            protected:
                Sample_FollowWaypoints_SendGoal_Request_DataReader () {};
                ~Sample_FollowWaypoints_SendGoal_Request_DataReader () {};
            private:
                Sample_FollowWaypoints_SendGoal_Request_DataReader (const Sample_FollowWaypoints_SendGoal_Request_DataReader &);
                Sample_FollowWaypoints_SendGoal_Request_DataReader & operator = (const Sample_FollowWaypoints_SendGoal_Request_DataReader &);
            };

            class  Sample_FollowWaypoints_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_SendGoal_Request_& instance) = 0;

            protected:
                Sample_FollowWaypoints_SendGoal_Request_DataReaderView () {};
                ~Sample_FollowWaypoints_SendGoal_Request_DataReaderView () {};
            private:
                Sample_FollowWaypoints_SendGoal_Request_DataReaderView (const Sample_FollowWaypoints_SendGoal_Request_DataReaderView &);
                Sample_FollowWaypoints_SendGoal_Request_DataReaderView & operator = (const Sample_FollowWaypoints_SendGoal_Request_DataReaderView &);
            };
            class Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface;

            typedef Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface * Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface> Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface> Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_out;


            class Sample_FollowWaypoints_SendGoal_Response_DataWriter;

            typedef Sample_FollowWaypoints_SendGoal_Response_DataWriter * Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Response_DataWriter> Sample_FollowWaypoints_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Response_DataWriter> Sample_FollowWaypoints_SendGoal_Response_DataWriter_out;


            class Sample_FollowWaypoints_SendGoal_Response_DataReader;

            typedef Sample_FollowWaypoints_SendGoal_Response_DataReader * Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Response_DataReader> Sample_FollowWaypoints_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Response_DataReader> Sample_FollowWaypoints_SendGoal_Response_DataReader_out;


            class Sample_FollowWaypoints_SendGoal_Response_DataReaderView;

            typedef Sample_FollowWaypoints_SendGoal_Response_DataReaderView * Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_SendGoal_Response_DataReaderView> Sample_FollowWaypoints_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_SendGoal_Response_DataReaderView> Sample_FollowWaypoints_SendGoal_Response_DataReaderView_out;

            struct Sample_FollowWaypoints_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_FollowWaypoints_SendGoal_Response_, struct Sample_FollowWaypoints_SendGoal_Response_Seq_uniq_> Sample_FollowWaypoints_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_FollowWaypoints_SendGoal_Response_Seq> Sample_FollowWaypoints_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_FollowWaypoints_SendGoal_Response_Seq> Sample_FollowWaypoints_SendGoal_Response_Seq_out;

            class  Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface (const Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface &);
                Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface & operator = (const Sample_FollowWaypoints_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_FollowWaypoints_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Response_DataWriter_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_FollowWaypoints_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_FollowWaypoints_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_FollowWaypoints_SendGoal_Response_DataWriter () {};
                ~Sample_FollowWaypoints_SendGoal_Response_DataWriter () {};
            private:
                Sample_FollowWaypoints_SendGoal_Response_DataWriter (const Sample_FollowWaypoints_SendGoal_Response_DataWriter &);
                Sample_FollowWaypoints_SendGoal_Response_DataWriter & operator = (const Sample_FollowWaypoints_SendGoal_Response_DataWriter &);
            };

            class  Sample_FollowWaypoints_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Response_DataReader_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_SendGoal_Response_& instance) = 0;

            protected:
                Sample_FollowWaypoints_SendGoal_Response_DataReader () {};
                ~Sample_FollowWaypoints_SendGoal_Response_DataReader () {};
            private:
                Sample_FollowWaypoints_SendGoal_Response_DataReader (const Sample_FollowWaypoints_SendGoal_Response_DataReader &);
                Sample_FollowWaypoints_SendGoal_Response_DataReader & operator = (const Sample_FollowWaypoints_SendGoal_Response_DataReader &);
            };

            class  Sample_FollowWaypoints_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_FollowWaypoints_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_SendGoal_Response_& instance) = 0;

            protected:
                Sample_FollowWaypoints_SendGoal_Response_DataReaderView () {};
                ~Sample_FollowWaypoints_SendGoal_Response_DataReaderView () {};
            private:
                Sample_FollowWaypoints_SendGoal_Response_DataReaderView (const Sample_FollowWaypoints_SendGoal_Response_DataReaderView &);
                Sample_FollowWaypoints_SendGoal_Response_DataReaderView & operator = (const Sample_FollowWaypoints_SendGoal_Response_DataReaderView &);
            };
            class FollowWaypoints_Result_TypeSupportInterface;

            typedef FollowWaypoints_Result_TypeSupportInterface * FollowWaypoints_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Result_TypeSupportInterface> FollowWaypoints_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Result_TypeSupportInterface> FollowWaypoints_Result_TypeSupportInterface_out;


            class FollowWaypoints_Result_DataWriter;

            typedef FollowWaypoints_Result_DataWriter * FollowWaypoints_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Result_DataWriter> FollowWaypoints_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Result_DataWriter> FollowWaypoints_Result_DataWriter_out;


            class FollowWaypoints_Result_DataReader;

            typedef FollowWaypoints_Result_DataReader * FollowWaypoints_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Result_DataReader> FollowWaypoints_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Result_DataReader> FollowWaypoints_Result_DataReader_out;


            class FollowWaypoints_Result_DataReaderView;

            typedef FollowWaypoints_Result_DataReaderView * FollowWaypoints_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Result_DataReaderView> FollowWaypoints_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Result_DataReaderView> FollowWaypoints_Result_DataReaderView_out;

            struct FollowWaypoints_Result_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FollowWaypoints_Result_, struct FollowWaypoints_Result_Seq_uniq_> FollowWaypoints_Result_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_Result_Seq> FollowWaypoints_Result_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_Result_Seq> FollowWaypoints_Result_Seq_out;

            class  FollowWaypoints_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_Result_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_Result_TypeSupportInterface_var _var_type;

                static FollowWaypoints_Result_TypeSupportInterface_ptr _duplicate (FollowWaypoints_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_Result_TypeSupportInterface () {};
                ~FollowWaypoints_Result_TypeSupportInterface () {};
            private:
                FollowWaypoints_Result_TypeSupportInterface (const FollowWaypoints_Result_TypeSupportInterface &);
                FollowWaypoints_Result_TypeSupportInterface & operator = (const FollowWaypoints_Result_TypeSupportInterface &);
            };

            class  FollowWaypoints_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_Result_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_Result_DataWriter_var _var_type;

                static FollowWaypoints_Result_DataWriter_ptr _duplicate (FollowWaypoints_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Result_& instance_data) = 0;

            protected:
                FollowWaypoints_Result_DataWriter () {};
                ~FollowWaypoints_Result_DataWriter () {};
            private:
                FollowWaypoints_Result_DataWriter (const FollowWaypoints_Result_DataWriter &);
                FollowWaypoints_Result_DataWriter & operator = (const FollowWaypoints_Result_DataWriter &);
            };

            class  FollowWaypoints_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_Result_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_Result_DataReader_var _var_type;

                static FollowWaypoints_Result_DataReader_ptr _duplicate (FollowWaypoints_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Result_& instance) = 0;

            protected:
                FollowWaypoints_Result_DataReader () {};
                ~FollowWaypoints_Result_DataReader () {};
            private:
                FollowWaypoints_Result_DataReader (const FollowWaypoints_Result_DataReader &);
                FollowWaypoints_Result_DataReader & operator = (const FollowWaypoints_Result_DataReader &);
            };

            class  FollowWaypoints_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_Result_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_Result_DataReaderView_var _var_type;

                static FollowWaypoints_Result_DataReaderView_ptr _duplicate (FollowWaypoints_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Result_& instance) = 0;

            protected:
                FollowWaypoints_Result_DataReaderView () {};
                ~FollowWaypoints_Result_DataReaderView () {};
            private:
                FollowWaypoints_Result_DataReaderView (const FollowWaypoints_Result_DataReaderView &);
                FollowWaypoints_Result_DataReaderView & operator = (const FollowWaypoints_Result_DataReaderView &);
            };
            class FollowWaypoints_GetResult_Request_TypeSupportInterface;

            typedef FollowWaypoints_GetResult_Request_TypeSupportInterface * FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Request_TypeSupportInterface> FollowWaypoints_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Request_TypeSupportInterface> FollowWaypoints_GetResult_Request_TypeSupportInterface_out;


            class FollowWaypoints_GetResult_Request_DataWriter;

            typedef FollowWaypoints_GetResult_Request_DataWriter * FollowWaypoints_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Request_DataWriter> FollowWaypoints_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Request_DataWriter> FollowWaypoints_GetResult_Request_DataWriter_out;


            class FollowWaypoints_GetResult_Request_DataReader;

            typedef FollowWaypoints_GetResult_Request_DataReader * FollowWaypoints_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Request_DataReader> FollowWaypoints_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Request_DataReader> FollowWaypoints_GetResult_Request_DataReader_out;


            class FollowWaypoints_GetResult_Request_DataReaderView;

            typedef FollowWaypoints_GetResult_Request_DataReaderView * FollowWaypoints_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Request_DataReaderView> FollowWaypoints_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Request_DataReaderView> FollowWaypoints_GetResult_Request_DataReaderView_out;

            struct FollowWaypoints_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < FollowWaypoints_GetResult_Request_, struct FollowWaypoints_GetResult_Request_Seq_uniq_> FollowWaypoints_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_GetResult_Request_Seq> FollowWaypoints_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_GetResult_Request_Seq> FollowWaypoints_GetResult_Request_Seq_out;

            class  FollowWaypoints_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Request_TypeSupportInterface_var _var_type;

                static FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _duplicate (FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_GetResult_Request_TypeSupportInterface () {};
                ~FollowWaypoints_GetResult_Request_TypeSupportInterface () {};
            private:
                FollowWaypoints_GetResult_Request_TypeSupportInterface (const FollowWaypoints_GetResult_Request_TypeSupportInterface &);
                FollowWaypoints_GetResult_Request_TypeSupportInterface & operator = (const FollowWaypoints_GetResult_Request_TypeSupportInterface &);
            };

            class  FollowWaypoints_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Request_DataWriter_var _var_type;

                static FollowWaypoints_GetResult_Request_DataWriter_ptr _duplicate (FollowWaypoints_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_GetResult_Request_& instance_data) = 0;

            protected:
                FollowWaypoints_GetResult_Request_DataWriter () {};
                ~FollowWaypoints_GetResult_Request_DataWriter () {};
            private:
                FollowWaypoints_GetResult_Request_DataWriter (const FollowWaypoints_GetResult_Request_DataWriter &);
                FollowWaypoints_GetResult_Request_DataWriter & operator = (const FollowWaypoints_GetResult_Request_DataWriter &);
            };

            class  FollowWaypoints_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_GetResult_Request_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Request_DataReader_var _var_type;

                static FollowWaypoints_GetResult_Request_DataReader_ptr _duplicate (FollowWaypoints_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_GetResult_Request_& instance) = 0;

            protected:
                FollowWaypoints_GetResult_Request_DataReader () {};
                ~FollowWaypoints_GetResult_Request_DataReader () {};
            private:
                FollowWaypoints_GetResult_Request_DataReader (const FollowWaypoints_GetResult_Request_DataReader &);
                FollowWaypoints_GetResult_Request_DataReader & operator = (const FollowWaypoints_GetResult_Request_DataReader &);
            };

            class  FollowWaypoints_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Request_DataReaderView_var _var_type;

                static FollowWaypoints_GetResult_Request_DataReaderView_ptr _duplicate (FollowWaypoints_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_GetResult_Request_& instance) = 0;

            protected:
                FollowWaypoints_GetResult_Request_DataReaderView () {};
                ~FollowWaypoints_GetResult_Request_DataReaderView () {};
            private:
                FollowWaypoints_GetResult_Request_DataReaderView (const FollowWaypoints_GetResult_Request_DataReaderView &);
                FollowWaypoints_GetResult_Request_DataReaderView & operator = (const FollowWaypoints_GetResult_Request_DataReaderView &);
            };
            class FollowWaypoints_GetResult_Response_TypeSupportInterface;

            typedef FollowWaypoints_GetResult_Response_TypeSupportInterface * FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Response_TypeSupportInterface> FollowWaypoints_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Response_TypeSupportInterface> FollowWaypoints_GetResult_Response_TypeSupportInterface_out;


            class FollowWaypoints_GetResult_Response_DataWriter;

            typedef FollowWaypoints_GetResult_Response_DataWriter * FollowWaypoints_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Response_DataWriter> FollowWaypoints_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Response_DataWriter> FollowWaypoints_GetResult_Response_DataWriter_out;


            class FollowWaypoints_GetResult_Response_DataReader;

            typedef FollowWaypoints_GetResult_Response_DataReader * FollowWaypoints_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Response_DataReader> FollowWaypoints_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Response_DataReader> FollowWaypoints_GetResult_Response_DataReader_out;


            class FollowWaypoints_GetResult_Response_DataReaderView;

            typedef FollowWaypoints_GetResult_Response_DataReaderView * FollowWaypoints_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_GetResult_Response_DataReaderView> FollowWaypoints_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_GetResult_Response_DataReaderView> FollowWaypoints_GetResult_Response_DataReaderView_out;

            struct FollowWaypoints_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FollowWaypoints_GetResult_Response_, struct FollowWaypoints_GetResult_Response_Seq_uniq_> FollowWaypoints_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_GetResult_Response_Seq> FollowWaypoints_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_GetResult_Response_Seq> FollowWaypoints_GetResult_Response_Seq_out;

            class  FollowWaypoints_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Response_TypeSupportInterface_var _var_type;

                static FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _duplicate (FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_GetResult_Response_TypeSupportInterface () {};
                ~FollowWaypoints_GetResult_Response_TypeSupportInterface () {};
            private:
                FollowWaypoints_GetResult_Response_TypeSupportInterface (const FollowWaypoints_GetResult_Response_TypeSupportInterface &);
                FollowWaypoints_GetResult_Response_TypeSupportInterface & operator = (const FollowWaypoints_GetResult_Response_TypeSupportInterface &);
            };

            class  FollowWaypoints_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Response_DataWriter_var _var_type;

                static FollowWaypoints_GetResult_Response_DataWriter_ptr _duplicate (FollowWaypoints_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_GetResult_Response_& instance_data) = 0;

            protected:
                FollowWaypoints_GetResult_Response_DataWriter () {};
                ~FollowWaypoints_GetResult_Response_DataWriter () {};
            private:
                FollowWaypoints_GetResult_Response_DataWriter (const FollowWaypoints_GetResult_Response_DataWriter &);
                FollowWaypoints_GetResult_Response_DataWriter & operator = (const FollowWaypoints_GetResult_Response_DataWriter &);
            };

            class  FollowWaypoints_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_GetResult_Response_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Response_DataReader_var _var_type;

                static FollowWaypoints_GetResult_Response_DataReader_ptr _duplicate (FollowWaypoints_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_GetResult_Response_& instance) = 0;

            protected:
                FollowWaypoints_GetResult_Response_DataReader () {};
                ~FollowWaypoints_GetResult_Response_DataReader () {};
            private:
                FollowWaypoints_GetResult_Response_DataReader (const FollowWaypoints_GetResult_Response_DataReader &);
                FollowWaypoints_GetResult_Response_DataReader & operator = (const FollowWaypoints_GetResult_Response_DataReader &);
            };

            class  FollowWaypoints_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_GetResult_Response_DataReaderView_var _var_type;

                static FollowWaypoints_GetResult_Response_DataReaderView_ptr _duplicate (FollowWaypoints_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_GetResult_Response_& instance) = 0;

            protected:
                FollowWaypoints_GetResult_Response_DataReaderView () {};
                ~FollowWaypoints_GetResult_Response_DataReaderView () {};
            private:
                FollowWaypoints_GetResult_Response_DataReaderView (const FollowWaypoints_GetResult_Response_DataReaderView &);
                FollowWaypoints_GetResult_Response_DataReaderView & operator = (const FollowWaypoints_GetResult_Response_DataReaderView &);
            };
            class Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface;

            typedef Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface * Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface> Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface> Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_out;


            class Sample_FollowWaypoints_GetResult_Request_DataWriter;

            typedef Sample_FollowWaypoints_GetResult_Request_DataWriter * Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Request_DataWriter> Sample_FollowWaypoints_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Request_DataWriter> Sample_FollowWaypoints_GetResult_Request_DataWriter_out;


            class Sample_FollowWaypoints_GetResult_Request_DataReader;

            typedef Sample_FollowWaypoints_GetResult_Request_DataReader * Sample_FollowWaypoints_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Request_DataReader> Sample_FollowWaypoints_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Request_DataReader> Sample_FollowWaypoints_GetResult_Request_DataReader_out;


            class Sample_FollowWaypoints_GetResult_Request_DataReaderView;

            typedef Sample_FollowWaypoints_GetResult_Request_DataReaderView * Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Request_DataReaderView> Sample_FollowWaypoints_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Request_DataReaderView> Sample_FollowWaypoints_GetResult_Request_DataReaderView_out;

            struct Sample_FollowWaypoints_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_FollowWaypoints_GetResult_Request_, struct Sample_FollowWaypoints_GetResult_Request_Seq_uniq_> Sample_FollowWaypoints_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_FollowWaypoints_GetResult_Request_Seq> Sample_FollowWaypoints_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_FollowWaypoints_GetResult_Request_Seq> Sample_FollowWaypoints_GetResult_Request_Seq_out;

            class  Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface () {};
                ~Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface (const Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface &);
                Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface & operator = (const Sample_FollowWaypoints_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_FollowWaypoints_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Request_DataWriter_var _var_type;

                static Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr _duplicate (Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_FollowWaypoints_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_FollowWaypoints_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_FollowWaypoints_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_FollowWaypoints_GetResult_Request_DataWriter () {};
                ~Sample_FollowWaypoints_GetResult_Request_DataWriter () {};
            private:
                Sample_FollowWaypoints_GetResult_Request_DataWriter (const Sample_FollowWaypoints_GetResult_Request_DataWriter &);
                Sample_FollowWaypoints_GetResult_Request_DataWriter & operator = (const Sample_FollowWaypoints_GetResult_Request_DataWriter &);
            };

            class  Sample_FollowWaypoints_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Request_DataReader_var _var_type;

                static Sample_FollowWaypoints_GetResult_Request_DataReader_ptr _duplicate (Sample_FollowWaypoints_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_GetResult_Request_& instance) = 0;

            protected:
                Sample_FollowWaypoints_GetResult_Request_DataReader () {};
                ~Sample_FollowWaypoints_GetResult_Request_DataReader () {};
            private:
                Sample_FollowWaypoints_GetResult_Request_DataReader (const Sample_FollowWaypoints_GetResult_Request_DataReader &);
                Sample_FollowWaypoints_GetResult_Request_DataReader & operator = (const Sample_FollowWaypoints_GetResult_Request_DataReader &);
            };

            class  Sample_FollowWaypoints_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Request_DataReaderView_var _var_type;

                static Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr _duplicate (Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_GetResult_Request_& instance) = 0;

            protected:
                Sample_FollowWaypoints_GetResult_Request_DataReaderView () {};
                ~Sample_FollowWaypoints_GetResult_Request_DataReaderView () {};
            private:
                Sample_FollowWaypoints_GetResult_Request_DataReaderView (const Sample_FollowWaypoints_GetResult_Request_DataReaderView &);
                Sample_FollowWaypoints_GetResult_Request_DataReaderView & operator = (const Sample_FollowWaypoints_GetResult_Request_DataReaderView &);
            };
            class Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface;

            typedef Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface * Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface> Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface> Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_out;


            class Sample_FollowWaypoints_GetResult_Response_DataWriter;

            typedef Sample_FollowWaypoints_GetResult_Response_DataWriter * Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Response_DataWriter> Sample_FollowWaypoints_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Response_DataWriter> Sample_FollowWaypoints_GetResult_Response_DataWriter_out;


            class Sample_FollowWaypoints_GetResult_Response_DataReader;

            typedef Sample_FollowWaypoints_GetResult_Response_DataReader * Sample_FollowWaypoints_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Response_DataReader> Sample_FollowWaypoints_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Response_DataReader> Sample_FollowWaypoints_GetResult_Response_DataReader_out;


            class Sample_FollowWaypoints_GetResult_Response_DataReaderView;

            typedef Sample_FollowWaypoints_GetResult_Response_DataReaderView * Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_FollowWaypoints_GetResult_Response_DataReaderView> Sample_FollowWaypoints_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_FollowWaypoints_GetResult_Response_DataReaderView> Sample_FollowWaypoints_GetResult_Response_DataReaderView_out;

            struct Sample_FollowWaypoints_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_FollowWaypoints_GetResult_Response_, struct Sample_FollowWaypoints_GetResult_Response_Seq_uniq_> Sample_FollowWaypoints_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_FollowWaypoints_GetResult_Response_Seq> Sample_FollowWaypoints_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_FollowWaypoints_GetResult_Response_Seq> Sample_FollowWaypoints_GetResult_Response_Seq_out;

            class  Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface () {};
                ~Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface (const Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface &);
                Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface & operator = (const Sample_FollowWaypoints_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_FollowWaypoints_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Response_DataWriter_var _var_type;

                static Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr _duplicate (Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_FollowWaypoints_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_FollowWaypoints_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_FollowWaypoints_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_FollowWaypoints_GetResult_Response_DataWriter () {};
                ~Sample_FollowWaypoints_GetResult_Response_DataWriter () {};
            private:
                Sample_FollowWaypoints_GetResult_Response_DataWriter (const Sample_FollowWaypoints_GetResult_Response_DataWriter &);
                Sample_FollowWaypoints_GetResult_Response_DataWriter & operator = (const Sample_FollowWaypoints_GetResult_Response_DataWriter &);
            };

            class  Sample_FollowWaypoints_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Response_DataReader_var _var_type;

                static Sample_FollowWaypoints_GetResult_Response_DataReader_ptr _duplicate (Sample_FollowWaypoints_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_GetResult_Response_& instance) = 0;

            protected:
                Sample_FollowWaypoints_GetResult_Response_DataReader () {};
                ~Sample_FollowWaypoints_GetResult_Response_DataReader () {};
            private:
                Sample_FollowWaypoints_GetResult_Response_DataReader (const Sample_FollowWaypoints_GetResult_Response_DataReader &);
                Sample_FollowWaypoints_GetResult_Response_DataReader & operator = (const Sample_FollowWaypoints_GetResult_Response_DataReader &);
            };

            class  Sample_FollowWaypoints_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_FollowWaypoints_GetResult_Response_DataReaderView_var _var_type;

                static Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr _duplicate (Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_FollowWaypoints_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_FollowWaypoints_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_FollowWaypoints_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_FollowWaypoints_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_FollowWaypoints_GetResult_Response_& instance) = 0;

            protected:
                Sample_FollowWaypoints_GetResult_Response_DataReaderView () {};
                ~Sample_FollowWaypoints_GetResult_Response_DataReaderView () {};
            private:
                Sample_FollowWaypoints_GetResult_Response_DataReaderView (const Sample_FollowWaypoints_GetResult_Response_DataReaderView &);
                Sample_FollowWaypoints_GetResult_Response_DataReaderView & operator = (const Sample_FollowWaypoints_GetResult_Response_DataReaderView &);
            };
            class FollowWaypoints_Feedback_TypeSupportInterface;

            typedef FollowWaypoints_Feedback_TypeSupportInterface * FollowWaypoints_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Feedback_TypeSupportInterface> FollowWaypoints_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Feedback_TypeSupportInterface> FollowWaypoints_Feedback_TypeSupportInterface_out;


            class FollowWaypoints_Feedback_DataWriter;

            typedef FollowWaypoints_Feedback_DataWriter * FollowWaypoints_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Feedback_DataWriter> FollowWaypoints_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Feedback_DataWriter> FollowWaypoints_Feedback_DataWriter_out;


            class FollowWaypoints_Feedback_DataReader;

            typedef FollowWaypoints_Feedback_DataReader * FollowWaypoints_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Feedback_DataReader> FollowWaypoints_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Feedback_DataReader> FollowWaypoints_Feedback_DataReader_out;


            class FollowWaypoints_Feedback_DataReaderView;

            typedef FollowWaypoints_Feedback_DataReaderView * FollowWaypoints_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_Feedback_DataReaderView> FollowWaypoints_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_Feedback_DataReaderView> FollowWaypoints_Feedback_DataReaderView_out;

            struct FollowWaypoints_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < FollowWaypoints_Feedback_, struct FollowWaypoints_Feedback_Seq_uniq_> FollowWaypoints_Feedback_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_Feedback_Seq> FollowWaypoints_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_Feedback_Seq> FollowWaypoints_Feedback_Seq_out;

            class  FollowWaypoints_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_Feedback_TypeSupportInterface_var _var_type;

                static FollowWaypoints_Feedback_TypeSupportInterface_ptr _duplicate (FollowWaypoints_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_Feedback_TypeSupportInterface () {};
                ~FollowWaypoints_Feedback_TypeSupportInterface () {};
            private:
                FollowWaypoints_Feedback_TypeSupportInterface (const FollowWaypoints_Feedback_TypeSupportInterface &);
                FollowWaypoints_Feedback_TypeSupportInterface & operator = (const FollowWaypoints_Feedback_TypeSupportInterface &);
            };

            class  FollowWaypoints_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_Feedback_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_Feedback_DataWriter_var _var_type;

                static FollowWaypoints_Feedback_DataWriter_ptr _duplicate (FollowWaypoints_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Feedback_& instance_data) = 0;

            protected:
                FollowWaypoints_Feedback_DataWriter () {};
                ~FollowWaypoints_Feedback_DataWriter () {};
            private:
                FollowWaypoints_Feedback_DataWriter (const FollowWaypoints_Feedback_DataWriter &);
                FollowWaypoints_Feedback_DataWriter & operator = (const FollowWaypoints_Feedback_DataWriter &);
            };

            class  FollowWaypoints_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_Feedback_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_Feedback_DataReader_var _var_type;

                static FollowWaypoints_Feedback_DataReader_ptr _duplicate (FollowWaypoints_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Feedback_& instance) = 0;

            protected:
                FollowWaypoints_Feedback_DataReader () {};
                ~FollowWaypoints_Feedback_DataReader () {};
            private:
                FollowWaypoints_Feedback_DataReader (const FollowWaypoints_Feedback_DataReader &);
                FollowWaypoints_Feedback_DataReader & operator = (const FollowWaypoints_Feedback_DataReader &);
            };

            class  FollowWaypoints_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_Feedback_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_Feedback_DataReaderView_var _var_type;

                static FollowWaypoints_Feedback_DataReaderView_ptr _duplicate (FollowWaypoints_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_Feedback_& instance) = 0;

            protected:
                FollowWaypoints_Feedback_DataReaderView () {};
                ~FollowWaypoints_Feedback_DataReaderView () {};
            private:
                FollowWaypoints_Feedback_DataReaderView (const FollowWaypoints_Feedback_DataReaderView &);
                FollowWaypoints_Feedback_DataReaderView & operator = (const FollowWaypoints_Feedback_DataReaderView &);
            };
            class FollowWaypoints_FeedbackMessage_TypeSupportInterface;

            typedef FollowWaypoints_FeedbackMessage_TypeSupportInterface * FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_FeedbackMessage_TypeSupportInterface> FollowWaypoints_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_FeedbackMessage_TypeSupportInterface> FollowWaypoints_FeedbackMessage_TypeSupportInterface_out;


            class FollowWaypoints_FeedbackMessage_DataWriter;

            typedef FollowWaypoints_FeedbackMessage_DataWriter * FollowWaypoints_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_FeedbackMessage_DataWriter> FollowWaypoints_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_FeedbackMessage_DataWriter> FollowWaypoints_FeedbackMessage_DataWriter_out;


            class FollowWaypoints_FeedbackMessage_DataReader;

            typedef FollowWaypoints_FeedbackMessage_DataReader * FollowWaypoints_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_FeedbackMessage_DataReader> FollowWaypoints_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_FeedbackMessage_DataReader> FollowWaypoints_FeedbackMessage_DataReader_out;


            class FollowWaypoints_FeedbackMessage_DataReaderView;

            typedef FollowWaypoints_FeedbackMessage_DataReaderView * FollowWaypoints_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FollowWaypoints_FeedbackMessage_DataReaderView> FollowWaypoints_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FollowWaypoints_FeedbackMessage_DataReaderView> FollowWaypoints_FeedbackMessage_DataReaderView_out;

            struct FollowWaypoints_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < FollowWaypoints_FeedbackMessage_, struct FollowWaypoints_FeedbackMessage_Seq_uniq_> FollowWaypoints_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < FollowWaypoints_FeedbackMessage_Seq> FollowWaypoints_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < FollowWaypoints_FeedbackMessage_Seq> FollowWaypoints_FeedbackMessage_Seq_out;

            class  FollowWaypoints_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef FollowWaypoints_FeedbackMessage_TypeSupportInterface_var _var_type;

                static FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr _duplicate (FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FollowWaypoints_FeedbackMessage_TypeSupportInterface () {};
                ~FollowWaypoints_FeedbackMessage_TypeSupportInterface () {};
            private:
                FollowWaypoints_FeedbackMessage_TypeSupportInterface (const FollowWaypoints_FeedbackMessage_TypeSupportInterface &);
                FollowWaypoints_FeedbackMessage_TypeSupportInterface & operator = (const FollowWaypoints_FeedbackMessage_TypeSupportInterface &);
            };

            class  FollowWaypoints_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FollowWaypoints_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef FollowWaypoints_FeedbackMessage_DataWriter_var _var_type;

                static FollowWaypoints_FeedbackMessage_DataWriter_ptr _duplicate (FollowWaypoints_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FollowWaypoints_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FollowWaypoints_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FollowWaypoints_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_FeedbackMessage_& instance_data) = 0;

            protected:
                FollowWaypoints_FeedbackMessage_DataWriter () {};
                ~FollowWaypoints_FeedbackMessage_DataWriter () {};
            private:
                FollowWaypoints_FeedbackMessage_DataWriter (const FollowWaypoints_FeedbackMessage_DataWriter &);
                FollowWaypoints_FeedbackMessage_DataWriter & operator = (const FollowWaypoints_FeedbackMessage_DataWriter &);
            };

            class  FollowWaypoints_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FollowWaypoints_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef FollowWaypoints_FeedbackMessage_DataReader_var _var_type;

                static FollowWaypoints_FeedbackMessage_DataReader_ptr _duplicate (FollowWaypoints_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_FeedbackMessage_& instance) = 0;

            protected:
                FollowWaypoints_FeedbackMessage_DataReader () {};
                ~FollowWaypoints_FeedbackMessage_DataReader () {};
            private:
                FollowWaypoints_FeedbackMessage_DataReader (const FollowWaypoints_FeedbackMessage_DataReader &);
                FollowWaypoints_FeedbackMessage_DataReader & operator = (const FollowWaypoints_FeedbackMessage_DataReader &);
            };

            class  FollowWaypoints_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FollowWaypoints_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef FollowWaypoints_FeedbackMessage_DataReaderView_var _var_type;

                static FollowWaypoints_FeedbackMessage_DataReaderView_ptr _duplicate (FollowWaypoints_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FollowWaypoints_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FollowWaypoints_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FollowWaypoints_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FollowWaypoints_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FollowWaypoints_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FollowWaypoints_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FollowWaypoints_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FollowWaypoints_FeedbackMessage_& instance) = 0;

            protected:
                FollowWaypoints_FeedbackMessage_DataReaderView () {};
                ~FollowWaypoints_FeedbackMessage_DataReaderView () {};
            private:
                FollowWaypoints_FeedbackMessage_DataReaderView (const FollowWaypoints_FeedbackMessage_DataReaderView &);
                FollowWaypoints_FeedbackMessage_DataReaderView & operator = (const FollowWaypoints_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
