#ifndef H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints_SPLTYPES_H
#define H_2B00C1E74DE40F6CD5834F7742693179_FollowWaypoints_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_FollowWaypoints_.h"
#include "geometry_msgs/msg/dds_opensplice/PoseStamped_SplDcps.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __FollowWaypoints__nav2_msgs__load (c_base base);

extern c_metaObject __FollowWaypoints__nav2_msgs_action__load (c_base base);

extern c_metaObject __FollowWaypoints__nav2_msgs_action_dds___load (c_base base);

extern const char *nav2_msgs_action_dds__FollowWaypoints_Goal__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_Goal__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_Goal__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_Goal___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_Goal_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_Goal___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_Goal_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_Goal_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_Goal___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_Goal_ {
    c_sequence poses_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_SendGoal_Request_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _nav2_msgs_action_dds__FollowWaypoints_Goal_ goal_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_SendGoal_Response_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request__metaDescriptor[];
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request___load (c_base base);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request_ ;
extern  v_copyin_result __nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request___copyIn(c_base base, const struct nav2_msgs::action::dds_::Sample_FollowWaypoints_SendGoal_Request_ *from, struct _nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request_ *to);
extern  void __nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Request_ request_;
};

extern const char *nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response__metaDescriptor[];
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response___load (c_base base);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response_ ;
extern  v_copyin_result __nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response___copyIn(c_base base, const struct nav2_msgs::action::dds_::Sample_FollowWaypoints_SendGoal_Response_ *from, struct _nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response_ *to);
extern  void __nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _nav2_msgs_action_dds__FollowWaypoints_SendGoal_Response_ response_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_Result__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_Result__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_Result__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_Result___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_Result_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_Result___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_Result_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_Result_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_Result___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_Result_ {
    c_sequence missed_waypoints_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_GetResult_Request__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_GetResult_Request__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_GetResult_Request__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_GetResult_Request___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Request_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_GetResult_Request___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_GetResult_Request_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Request_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_GetResult_Request___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_GetResult_Response__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_GetResult_Response__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_GetResult_Response__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_GetResult_Response___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Response_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_GetResult_Response___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_GetResult_Response_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Response_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_GetResult_Response___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Response_ {
    c_octet status_;
    struct _nav2_msgs_action_dds__FollowWaypoints_Result_ result_;
};

extern const char *nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request__metaDescriptor[];
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request___load (c_base base);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request_ ;
extern  v_copyin_result __nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request___copyIn(c_base base, const struct nav2_msgs::action::dds_::Sample_FollowWaypoints_GetResult_Request_ *from, struct _nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request_ *to);
extern  void __nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Request_ request_;
};

extern const char *nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response__metaDescriptor[];
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response___load (c_base base);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response_ ;
extern  v_copyin_result __nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response___copyIn(c_base base, const struct nav2_msgs::action::dds_::Sample_FollowWaypoints_GetResult_Response_ *from, struct _nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response_ *to);
extern  void __nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__Sample_FollowWaypoints_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _nav2_msgs_action_dds__FollowWaypoints_GetResult_Response_ response_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_Feedback__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_Feedback__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_Feedback__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_Feedback___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_Feedback_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_Feedback___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_Feedback_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_Feedback_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_Feedback___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_Feedback_ {
    c_ulong current_waypoint_;
};

extern const char *nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage__metaDescriptor[];
extern const int nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage__metaDescriptorArrLength;
extern const int nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage___load (c_base base);
struct _nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage_ ;
extern  v_copyin_result __nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage___copyIn(c_base base, const struct nav2_msgs::action::dds_::FollowWaypoints_FeedbackMessage_ *from, struct _nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage_ *to);
extern  void __nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _nav2_msgs_action_dds__FollowWaypoints_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _nav2_msgs_action_dds__FollowWaypoints_Feedback_ feedback_;
};

#undef OS_API
#endif
