#ifndef _H_EF3A3B37E6AA0751F3E5E1E5D056F88D_Wait_DCPS_H_
#define _H_EF3A3B37E6AA0751F3E5E1E5D056F88D_Wait_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Wait_.h"


namespace nav2_msgs
{
    namespace action
    {
        namespace dds_
        {
            class Wait_Goal_TypeSupportInterface;

            typedef Wait_Goal_TypeSupportInterface * Wait_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_Goal_TypeSupportInterface> Wait_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_Goal_TypeSupportInterface> Wait_Goal_TypeSupportInterface_out;


            class Wait_Goal_DataWriter;

            typedef Wait_Goal_DataWriter * Wait_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_Goal_DataWriter> Wait_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_Goal_DataWriter> Wait_Goal_DataWriter_out;


            class Wait_Goal_DataReader;

            typedef Wait_Goal_DataReader * Wait_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_Goal_DataReader> Wait_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_Goal_DataReader> Wait_Goal_DataReader_out;


            class Wait_Goal_DataReaderView;

            typedef Wait_Goal_DataReaderView * Wait_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_Goal_DataReaderView> Wait_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_Goal_DataReaderView> Wait_Goal_DataReaderView_out;

            struct Wait_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_Goal_, struct Wait_Goal_Seq_uniq_> Wait_Goal_Seq;
            typedef DDS_DCPSSequence_var < Wait_Goal_Seq> Wait_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_Goal_Seq> Wait_Goal_Seq_out;

            class  Wait_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_Goal_TypeSupportInterface_var _var_type;

                static Wait_Goal_TypeSupportInterface_ptr _duplicate (Wait_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_Goal_TypeSupportInterface () {};
                ~Wait_Goal_TypeSupportInterface () {};
            private:
                Wait_Goal_TypeSupportInterface (const Wait_Goal_TypeSupportInterface &);
                Wait_Goal_TypeSupportInterface & operator = (const Wait_Goal_TypeSupportInterface &);
            };

            class  Wait_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_Goal_DataWriter_ptr _ptr_type;
                typedef Wait_Goal_DataWriter_var _var_type;

                static Wait_Goal_DataWriter_ptr _duplicate (Wait_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Goal_& instance_data) = 0;

            protected:
                Wait_Goal_DataWriter () {};
                ~Wait_Goal_DataWriter () {};
            private:
                Wait_Goal_DataWriter (const Wait_Goal_DataWriter &);
                Wait_Goal_DataWriter & operator = (const Wait_Goal_DataWriter &);
            };

            class  Wait_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_Goal_DataReader_ptr _ptr_type;
                typedef Wait_Goal_DataReader_var _var_type;

                static Wait_Goal_DataReader_ptr _duplicate (Wait_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Goal_& instance) = 0;

            protected:
                Wait_Goal_DataReader () {};
                ~Wait_Goal_DataReader () {};
            private:
                Wait_Goal_DataReader (const Wait_Goal_DataReader &);
                Wait_Goal_DataReader & operator = (const Wait_Goal_DataReader &);
            };

            class  Wait_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_Goal_DataReaderView_ptr _ptr_type;
                typedef Wait_Goal_DataReaderView_var _var_type;

                static Wait_Goal_DataReaderView_ptr _duplicate (Wait_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Goal_& instance) = 0;

            protected:
                Wait_Goal_DataReaderView () {};
                ~Wait_Goal_DataReaderView () {};
            private:
                Wait_Goal_DataReaderView (const Wait_Goal_DataReaderView &);
                Wait_Goal_DataReaderView & operator = (const Wait_Goal_DataReaderView &);
            };
            class Wait_SendGoal_Request_TypeSupportInterface;

            typedef Wait_SendGoal_Request_TypeSupportInterface * Wait_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Request_TypeSupportInterface> Wait_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Request_TypeSupportInterface> Wait_SendGoal_Request_TypeSupportInterface_out;


            class Wait_SendGoal_Request_DataWriter;

            typedef Wait_SendGoal_Request_DataWriter * Wait_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Request_DataWriter> Wait_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Request_DataWriter> Wait_SendGoal_Request_DataWriter_out;


            class Wait_SendGoal_Request_DataReader;

            typedef Wait_SendGoal_Request_DataReader * Wait_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Request_DataReader> Wait_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Request_DataReader> Wait_SendGoal_Request_DataReader_out;


            class Wait_SendGoal_Request_DataReaderView;

            typedef Wait_SendGoal_Request_DataReaderView * Wait_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Request_DataReaderView> Wait_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Request_DataReaderView> Wait_SendGoal_Request_DataReaderView_out;

            struct Wait_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_SendGoal_Request_, struct Wait_SendGoal_Request_Seq_uniq_> Wait_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Wait_SendGoal_Request_Seq> Wait_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_SendGoal_Request_Seq> Wait_SendGoal_Request_Seq_out;

            class  Wait_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Wait_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Wait_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_SendGoal_Request_TypeSupportInterface () {};
                ~Wait_SendGoal_Request_TypeSupportInterface () {};
            private:
                Wait_SendGoal_Request_TypeSupportInterface (const Wait_SendGoal_Request_TypeSupportInterface &);
                Wait_SendGoal_Request_TypeSupportInterface & operator = (const Wait_SendGoal_Request_TypeSupportInterface &);
            };

            class  Wait_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Wait_SendGoal_Request_DataWriter_var _var_type;

                static Wait_SendGoal_Request_DataWriter_ptr _duplicate (Wait_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_SendGoal_Request_& instance_data) = 0;

            protected:
                Wait_SendGoal_Request_DataWriter () {};
                ~Wait_SendGoal_Request_DataWriter () {};
            private:
                Wait_SendGoal_Request_DataWriter (const Wait_SendGoal_Request_DataWriter &);
                Wait_SendGoal_Request_DataWriter & operator = (const Wait_SendGoal_Request_DataWriter &);
            };

            class  Wait_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Wait_SendGoal_Request_DataReader_var _var_type;

                static Wait_SendGoal_Request_DataReader_ptr _duplicate (Wait_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_SendGoal_Request_& instance) = 0;

            protected:
                Wait_SendGoal_Request_DataReader () {};
                ~Wait_SendGoal_Request_DataReader () {};
            private:
                Wait_SendGoal_Request_DataReader (const Wait_SendGoal_Request_DataReader &);
                Wait_SendGoal_Request_DataReader & operator = (const Wait_SendGoal_Request_DataReader &);
            };

            class  Wait_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Wait_SendGoal_Request_DataReaderView_var _var_type;

                static Wait_SendGoal_Request_DataReaderView_ptr _duplicate (Wait_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_SendGoal_Request_& instance) = 0;

            protected:
                Wait_SendGoal_Request_DataReaderView () {};
                ~Wait_SendGoal_Request_DataReaderView () {};
            private:
                Wait_SendGoal_Request_DataReaderView (const Wait_SendGoal_Request_DataReaderView &);
                Wait_SendGoal_Request_DataReaderView & operator = (const Wait_SendGoal_Request_DataReaderView &);
            };
            class Wait_SendGoal_Response_TypeSupportInterface;

            typedef Wait_SendGoal_Response_TypeSupportInterface * Wait_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Response_TypeSupportInterface> Wait_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Response_TypeSupportInterface> Wait_SendGoal_Response_TypeSupportInterface_out;


            class Wait_SendGoal_Response_DataWriter;

            typedef Wait_SendGoal_Response_DataWriter * Wait_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Response_DataWriter> Wait_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Response_DataWriter> Wait_SendGoal_Response_DataWriter_out;


            class Wait_SendGoal_Response_DataReader;

            typedef Wait_SendGoal_Response_DataReader * Wait_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Response_DataReader> Wait_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Response_DataReader> Wait_SendGoal_Response_DataReader_out;


            class Wait_SendGoal_Response_DataReaderView;

            typedef Wait_SendGoal_Response_DataReaderView * Wait_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_SendGoal_Response_DataReaderView> Wait_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_SendGoal_Response_DataReaderView> Wait_SendGoal_Response_DataReaderView_out;

            struct Wait_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_SendGoal_Response_, struct Wait_SendGoal_Response_Seq_uniq_> Wait_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Wait_SendGoal_Response_Seq> Wait_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_SendGoal_Response_Seq> Wait_SendGoal_Response_Seq_out;

            class  Wait_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Wait_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Wait_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_SendGoal_Response_TypeSupportInterface () {};
                ~Wait_SendGoal_Response_TypeSupportInterface () {};
            private:
                Wait_SendGoal_Response_TypeSupportInterface (const Wait_SendGoal_Response_TypeSupportInterface &);
                Wait_SendGoal_Response_TypeSupportInterface & operator = (const Wait_SendGoal_Response_TypeSupportInterface &);
            };

            class  Wait_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Wait_SendGoal_Response_DataWriter_var _var_type;

                static Wait_SendGoal_Response_DataWriter_ptr _duplicate (Wait_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_SendGoal_Response_& instance_data) = 0;

            protected:
                Wait_SendGoal_Response_DataWriter () {};
                ~Wait_SendGoal_Response_DataWriter () {};
            private:
                Wait_SendGoal_Response_DataWriter (const Wait_SendGoal_Response_DataWriter &);
                Wait_SendGoal_Response_DataWriter & operator = (const Wait_SendGoal_Response_DataWriter &);
            };

            class  Wait_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Wait_SendGoal_Response_DataReader_var _var_type;

                static Wait_SendGoal_Response_DataReader_ptr _duplicate (Wait_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_SendGoal_Response_& instance) = 0;

            protected:
                Wait_SendGoal_Response_DataReader () {};
                ~Wait_SendGoal_Response_DataReader () {};
            private:
                Wait_SendGoal_Response_DataReader (const Wait_SendGoal_Response_DataReader &);
                Wait_SendGoal_Response_DataReader & operator = (const Wait_SendGoal_Response_DataReader &);
            };

            class  Wait_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Wait_SendGoal_Response_DataReaderView_var _var_type;

                static Wait_SendGoal_Response_DataReaderView_ptr _duplicate (Wait_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_SendGoal_Response_& instance) = 0;

            protected:
                Wait_SendGoal_Response_DataReaderView () {};
                ~Wait_SendGoal_Response_DataReaderView () {};
            private:
                Wait_SendGoal_Response_DataReaderView (const Wait_SendGoal_Response_DataReaderView &);
                Wait_SendGoal_Response_DataReaderView & operator = (const Wait_SendGoal_Response_DataReaderView &);
            };
            class Sample_Wait_SendGoal_Request_TypeSupportInterface;

            typedef Sample_Wait_SendGoal_Request_TypeSupportInterface * Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Request_TypeSupportInterface> Sample_Wait_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Request_TypeSupportInterface> Sample_Wait_SendGoal_Request_TypeSupportInterface_out;


            class Sample_Wait_SendGoal_Request_DataWriter;

            typedef Sample_Wait_SendGoal_Request_DataWriter * Sample_Wait_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Request_DataWriter> Sample_Wait_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Request_DataWriter> Sample_Wait_SendGoal_Request_DataWriter_out;


            class Sample_Wait_SendGoal_Request_DataReader;

            typedef Sample_Wait_SendGoal_Request_DataReader * Sample_Wait_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Request_DataReader> Sample_Wait_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Request_DataReader> Sample_Wait_SendGoal_Request_DataReader_out;


            class Sample_Wait_SendGoal_Request_DataReaderView;

            typedef Sample_Wait_SendGoal_Request_DataReaderView * Sample_Wait_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Request_DataReaderView> Sample_Wait_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Request_DataReaderView> Sample_Wait_SendGoal_Request_DataReaderView_out;

            struct Sample_Wait_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Wait_SendGoal_Request_, struct Sample_Wait_SendGoal_Request_Seq_uniq_> Sample_Wait_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Wait_SendGoal_Request_Seq> Sample_Wait_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Wait_SendGoal_Request_Seq> Sample_Wait_SendGoal_Request_Seq_out;

            class  Sample_Wait_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Wait_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_Wait_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_Wait_SendGoal_Request_TypeSupportInterface (const Sample_Wait_SendGoal_Request_TypeSupportInterface &);
                Sample_Wait_SendGoal_Request_TypeSupportInterface & operator = (const Sample_Wait_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_Wait_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Wait_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Request_DataWriter_var _var_type;

                static Sample_Wait_SendGoal_Request_DataWriter_ptr _duplicate (Sample_Wait_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Wait_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Wait_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Wait_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_Wait_SendGoal_Request_DataWriter () {};
                ~Sample_Wait_SendGoal_Request_DataWriter () {};
            private:
                Sample_Wait_SendGoal_Request_DataWriter (const Sample_Wait_SendGoal_Request_DataWriter &);
                Sample_Wait_SendGoal_Request_DataWriter & operator = (const Sample_Wait_SendGoal_Request_DataWriter &);
            };

            class  Sample_Wait_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Wait_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Request_DataReader_var _var_type;

                static Sample_Wait_SendGoal_Request_DataReader_ptr _duplicate (Sample_Wait_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Wait_SendGoal_Request_DataReader () {};
                ~Sample_Wait_SendGoal_Request_DataReader () {};
            private:
                Sample_Wait_SendGoal_Request_DataReader (const Sample_Wait_SendGoal_Request_DataReader &);
                Sample_Wait_SendGoal_Request_DataReader & operator = (const Sample_Wait_SendGoal_Request_DataReader &);
            };

            class  Sample_Wait_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Wait_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_Wait_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_Wait_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Wait_SendGoal_Request_DataReaderView () {};
                ~Sample_Wait_SendGoal_Request_DataReaderView () {};
            private:
                Sample_Wait_SendGoal_Request_DataReaderView (const Sample_Wait_SendGoal_Request_DataReaderView &);
                Sample_Wait_SendGoal_Request_DataReaderView & operator = (const Sample_Wait_SendGoal_Request_DataReaderView &);
            };
            class Sample_Wait_SendGoal_Response_TypeSupportInterface;

            typedef Sample_Wait_SendGoal_Response_TypeSupportInterface * Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Response_TypeSupportInterface> Sample_Wait_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Response_TypeSupportInterface> Sample_Wait_SendGoal_Response_TypeSupportInterface_out;


            class Sample_Wait_SendGoal_Response_DataWriter;

            typedef Sample_Wait_SendGoal_Response_DataWriter * Sample_Wait_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Response_DataWriter> Sample_Wait_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Response_DataWriter> Sample_Wait_SendGoal_Response_DataWriter_out;


            class Sample_Wait_SendGoal_Response_DataReader;

            typedef Sample_Wait_SendGoal_Response_DataReader * Sample_Wait_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Response_DataReader> Sample_Wait_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Response_DataReader> Sample_Wait_SendGoal_Response_DataReader_out;


            class Sample_Wait_SendGoal_Response_DataReaderView;

            typedef Sample_Wait_SendGoal_Response_DataReaderView * Sample_Wait_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_SendGoal_Response_DataReaderView> Sample_Wait_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_SendGoal_Response_DataReaderView> Sample_Wait_SendGoal_Response_DataReaderView_out;

            struct Sample_Wait_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Wait_SendGoal_Response_, struct Sample_Wait_SendGoal_Response_Seq_uniq_> Sample_Wait_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Wait_SendGoal_Response_Seq> Sample_Wait_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Wait_SendGoal_Response_Seq> Sample_Wait_SendGoal_Response_Seq_out;

            class  Sample_Wait_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Wait_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_Wait_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_Wait_SendGoal_Response_TypeSupportInterface (const Sample_Wait_SendGoal_Response_TypeSupportInterface &);
                Sample_Wait_SendGoal_Response_TypeSupportInterface & operator = (const Sample_Wait_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_Wait_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Wait_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Response_DataWriter_var _var_type;

                static Sample_Wait_SendGoal_Response_DataWriter_ptr _duplicate (Sample_Wait_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Wait_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Wait_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Wait_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_Wait_SendGoal_Response_DataWriter () {};
                ~Sample_Wait_SendGoal_Response_DataWriter () {};
            private:
                Sample_Wait_SendGoal_Response_DataWriter (const Sample_Wait_SendGoal_Response_DataWriter &);
                Sample_Wait_SendGoal_Response_DataWriter & operator = (const Sample_Wait_SendGoal_Response_DataWriter &);
            };

            class  Sample_Wait_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Wait_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Response_DataReader_var _var_type;

                static Sample_Wait_SendGoal_Response_DataReader_ptr _duplicate (Sample_Wait_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Wait_SendGoal_Response_DataReader () {};
                ~Sample_Wait_SendGoal_Response_DataReader () {};
            private:
                Sample_Wait_SendGoal_Response_DataReader (const Sample_Wait_SendGoal_Response_DataReader &);
                Sample_Wait_SendGoal_Response_DataReader & operator = (const Sample_Wait_SendGoal_Response_DataReader &);
            };

            class  Sample_Wait_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Wait_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Wait_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_Wait_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_Wait_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Wait_SendGoal_Response_DataReaderView () {};
                ~Sample_Wait_SendGoal_Response_DataReaderView () {};
            private:
                Sample_Wait_SendGoal_Response_DataReaderView (const Sample_Wait_SendGoal_Response_DataReaderView &);
                Sample_Wait_SendGoal_Response_DataReaderView & operator = (const Sample_Wait_SendGoal_Response_DataReaderView &);
            };
            class Wait_Result_TypeSupportInterface;

            typedef Wait_Result_TypeSupportInterface * Wait_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_Result_TypeSupportInterface> Wait_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_Result_TypeSupportInterface> Wait_Result_TypeSupportInterface_out;


            class Wait_Result_DataWriter;

            typedef Wait_Result_DataWriter * Wait_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_Result_DataWriter> Wait_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_Result_DataWriter> Wait_Result_DataWriter_out;


            class Wait_Result_DataReader;

            typedef Wait_Result_DataReader * Wait_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_Result_DataReader> Wait_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_Result_DataReader> Wait_Result_DataReader_out;


            class Wait_Result_DataReaderView;

            typedef Wait_Result_DataReaderView * Wait_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_Result_DataReaderView> Wait_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_Result_DataReaderView> Wait_Result_DataReaderView_out;

            struct Wait_Result_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_Result_, struct Wait_Result_Seq_uniq_> Wait_Result_Seq;
            typedef DDS_DCPSSequence_var < Wait_Result_Seq> Wait_Result_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_Result_Seq> Wait_Result_Seq_out;

            class  Wait_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_Result_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_Result_TypeSupportInterface_var _var_type;

                static Wait_Result_TypeSupportInterface_ptr _duplicate (Wait_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_Result_TypeSupportInterface () {};
                ~Wait_Result_TypeSupportInterface () {};
            private:
                Wait_Result_TypeSupportInterface (const Wait_Result_TypeSupportInterface &);
                Wait_Result_TypeSupportInterface & operator = (const Wait_Result_TypeSupportInterface &);
            };

            class  Wait_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_Result_DataWriter_ptr _ptr_type;
                typedef Wait_Result_DataWriter_var _var_type;

                static Wait_Result_DataWriter_ptr _duplicate (Wait_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Result_& instance_data) = 0;

            protected:
                Wait_Result_DataWriter () {};
                ~Wait_Result_DataWriter () {};
            private:
                Wait_Result_DataWriter (const Wait_Result_DataWriter &);
                Wait_Result_DataWriter & operator = (const Wait_Result_DataWriter &);
            };

            class  Wait_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_Result_DataReader_ptr _ptr_type;
                typedef Wait_Result_DataReader_var _var_type;

                static Wait_Result_DataReader_ptr _duplicate (Wait_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Result_& instance) = 0;

            protected:
                Wait_Result_DataReader () {};
                ~Wait_Result_DataReader () {};
            private:
                Wait_Result_DataReader (const Wait_Result_DataReader &);
                Wait_Result_DataReader & operator = (const Wait_Result_DataReader &);
            };

            class  Wait_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_Result_DataReaderView_ptr _ptr_type;
                typedef Wait_Result_DataReaderView_var _var_type;

                static Wait_Result_DataReaderView_ptr _duplicate (Wait_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Result_& instance) = 0;

            protected:
                Wait_Result_DataReaderView () {};
                ~Wait_Result_DataReaderView () {};
            private:
                Wait_Result_DataReaderView (const Wait_Result_DataReaderView &);
                Wait_Result_DataReaderView & operator = (const Wait_Result_DataReaderView &);
            };
            class Wait_GetResult_Request_TypeSupportInterface;

            typedef Wait_GetResult_Request_TypeSupportInterface * Wait_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Request_TypeSupportInterface> Wait_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Request_TypeSupportInterface> Wait_GetResult_Request_TypeSupportInterface_out;


            class Wait_GetResult_Request_DataWriter;

            typedef Wait_GetResult_Request_DataWriter * Wait_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Request_DataWriter> Wait_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Request_DataWriter> Wait_GetResult_Request_DataWriter_out;


            class Wait_GetResult_Request_DataReader;

            typedef Wait_GetResult_Request_DataReader * Wait_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Request_DataReader> Wait_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Request_DataReader> Wait_GetResult_Request_DataReader_out;


            class Wait_GetResult_Request_DataReaderView;

            typedef Wait_GetResult_Request_DataReaderView * Wait_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Request_DataReaderView> Wait_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Request_DataReaderView> Wait_GetResult_Request_DataReaderView_out;

            struct Wait_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_GetResult_Request_, struct Wait_GetResult_Request_Seq_uniq_> Wait_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Wait_GetResult_Request_Seq> Wait_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_GetResult_Request_Seq> Wait_GetResult_Request_Seq_out;

            class  Wait_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_GetResult_Request_TypeSupportInterface_var _var_type;

                static Wait_GetResult_Request_TypeSupportInterface_ptr _duplicate (Wait_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_GetResult_Request_TypeSupportInterface () {};
                ~Wait_GetResult_Request_TypeSupportInterface () {};
            private:
                Wait_GetResult_Request_TypeSupportInterface (const Wait_GetResult_Request_TypeSupportInterface &);
                Wait_GetResult_Request_TypeSupportInterface & operator = (const Wait_GetResult_Request_TypeSupportInterface &);
            };

            class  Wait_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Wait_GetResult_Request_DataWriter_var _var_type;

                static Wait_GetResult_Request_DataWriter_ptr _duplicate (Wait_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_GetResult_Request_& instance_data) = 0;

            protected:
                Wait_GetResult_Request_DataWriter () {};
                ~Wait_GetResult_Request_DataWriter () {};
            private:
                Wait_GetResult_Request_DataWriter (const Wait_GetResult_Request_DataWriter &);
                Wait_GetResult_Request_DataWriter & operator = (const Wait_GetResult_Request_DataWriter &);
            };

            class  Wait_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Wait_GetResult_Request_DataReader_var _var_type;

                static Wait_GetResult_Request_DataReader_ptr _duplicate (Wait_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_GetResult_Request_& instance) = 0;

            protected:
                Wait_GetResult_Request_DataReader () {};
                ~Wait_GetResult_Request_DataReader () {};
            private:
                Wait_GetResult_Request_DataReader (const Wait_GetResult_Request_DataReader &);
                Wait_GetResult_Request_DataReader & operator = (const Wait_GetResult_Request_DataReader &);
            };

            class  Wait_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Wait_GetResult_Request_DataReaderView_var _var_type;

                static Wait_GetResult_Request_DataReaderView_ptr _duplicate (Wait_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_GetResult_Request_& instance) = 0;

            protected:
                Wait_GetResult_Request_DataReaderView () {};
                ~Wait_GetResult_Request_DataReaderView () {};
            private:
                Wait_GetResult_Request_DataReaderView (const Wait_GetResult_Request_DataReaderView &);
                Wait_GetResult_Request_DataReaderView & operator = (const Wait_GetResult_Request_DataReaderView &);
            };
            class Wait_GetResult_Response_TypeSupportInterface;

            typedef Wait_GetResult_Response_TypeSupportInterface * Wait_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Response_TypeSupportInterface> Wait_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Response_TypeSupportInterface> Wait_GetResult_Response_TypeSupportInterface_out;


            class Wait_GetResult_Response_DataWriter;

            typedef Wait_GetResult_Response_DataWriter * Wait_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Response_DataWriter> Wait_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Response_DataWriter> Wait_GetResult_Response_DataWriter_out;


            class Wait_GetResult_Response_DataReader;

            typedef Wait_GetResult_Response_DataReader * Wait_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Response_DataReader> Wait_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Response_DataReader> Wait_GetResult_Response_DataReader_out;


            class Wait_GetResult_Response_DataReaderView;

            typedef Wait_GetResult_Response_DataReaderView * Wait_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_GetResult_Response_DataReaderView> Wait_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_GetResult_Response_DataReaderView> Wait_GetResult_Response_DataReaderView_out;

            struct Wait_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_GetResult_Response_, struct Wait_GetResult_Response_Seq_uniq_> Wait_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Wait_GetResult_Response_Seq> Wait_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_GetResult_Response_Seq> Wait_GetResult_Response_Seq_out;

            class  Wait_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_GetResult_Response_TypeSupportInterface_var _var_type;

                static Wait_GetResult_Response_TypeSupportInterface_ptr _duplicate (Wait_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_GetResult_Response_TypeSupportInterface () {};
                ~Wait_GetResult_Response_TypeSupportInterface () {};
            private:
                Wait_GetResult_Response_TypeSupportInterface (const Wait_GetResult_Response_TypeSupportInterface &);
                Wait_GetResult_Response_TypeSupportInterface & operator = (const Wait_GetResult_Response_TypeSupportInterface &);
            };

            class  Wait_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Wait_GetResult_Response_DataWriter_var _var_type;

                static Wait_GetResult_Response_DataWriter_ptr _duplicate (Wait_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_GetResult_Response_& instance_data) = 0;

            protected:
                Wait_GetResult_Response_DataWriter () {};
                ~Wait_GetResult_Response_DataWriter () {};
            private:
                Wait_GetResult_Response_DataWriter (const Wait_GetResult_Response_DataWriter &);
                Wait_GetResult_Response_DataWriter & operator = (const Wait_GetResult_Response_DataWriter &);
            };

            class  Wait_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Wait_GetResult_Response_DataReader_var _var_type;

                static Wait_GetResult_Response_DataReader_ptr _duplicate (Wait_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_GetResult_Response_& instance) = 0;

            protected:
                Wait_GetResult_Response_DataReader () {};
                ~Wait_GetResult_Response_DataReader () {};
            private:
                Wait_GetResult_Response_DataReader (const Wait_GetResult_Response_DataReader &);
                Wait_GetResult_Response_DataReader & operator = (const Wait_GetResult_Response_DataReader &);
            };

            class  Wait_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Wait_GetResult_Response_DataReaderView_var _var_type;

                static Wait_GetResult_Response_DataReaderView_ptr _duplicate (Wait_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_GetResult_Response_& instance) = 0;

            protected:
                Wait_GetResult_Response_DataReaderView () {};
                ~Wait_GetResult_Response_DataReaderView () {};
            private:
                Wait_GetResult_Response_DataReaderView (const Wait_GetResult_Response_DataReaderView &);
                Wait_GetResult_Response_DataReaderView & operator = (const Wait_GetResult_Response_DataReaderView &);
            };
            class Sample_Wait_GetResult_Request_TypeSupportInterface;

            typedef Sample_Wait_GetResult_Request_TypeSupportInterface * Sample_Wait_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Request_TypeSupportInterface> Sample_Wait_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Request_TypeSupportInterface> Sample_Wait_GetResult_Request_TypeSupportInterface_out;


            class Sample_Wait_GetResult_Request_DataWriter;

            typedef Sample_Wait_GetResult_Request_DataWriter * Sample_Wait_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Request_DataWriter> Sample_Wait_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Request_DataWriter> Sample_Wait_GetResult_Request_DataWriter_out;


            class Sample_Wait_GetResult_Request_DataReader;

            typedef Sample_Wait_GetResult_Request_DataReader * Sample_Wait_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Request_DataReader> Sample_Wait_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Request_DataReader> Sample_Wait_GetResult_Request_DataReader_out;


            class Sample_Wait_GetResult_Request_DataReaderView;

            typedef Sample_Wait_GetResult_Request_DataReaderView * Sample_Wait_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Request_DataReaderView> Sample_Wait_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Request_DataReaderView> Sample_Wait_GetResult_Request_DataReaderView_out;

            struct Sample_Wait_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Wait_GetResult_Request_, struct Sample_Wait_GetResult_Request_Seq_uniq_> Sample_Wait_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Wait_GetResult_Request_Seq> Sample_Wait_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Wait_GetResult_Request_Seq> Sample_Wait_GetResult_Request_Seq_out;

            class  Sample_Wait_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Wait_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_Wait_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_Wait_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Wait_GetResult_Request_TypeSupportInterface () {};
                ~Sample_Wait_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_Wait_GetResult_Request_TypeSupportInterface (const Sample_Wait_GetResult_Request_TypeSupportInterface &);
                Sample_Wait_GetResult_Request_TypeSupportInterface & operator = (const Sample_Wait_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_Wait_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Wait_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Request_DataWriter_var _var_type;

                static Sample_Wait_GetResult_Request_DataWriter_ptr _duplicate (Sample_Wait_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Wait_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Wait_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Wait_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_Wait_GetResult_Request_DataWriter () {};
                ~Sample_Wait_GetResult_Request_DataWriter () {};
            private:
                Sample_Wait_GetResult_Request_DataWriter (const Sample_Wait_GetResult_Request_DataWriter &);
                Sample_Wait_GetResult_Request_DataWriter & operator = (const Sample_Wait_GetResult_Request_DataWriter &);
            };

            class  Sample_Wait_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Wait_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Request_DataReader_var _var_type;

                static Sample_Wait_GetResult_Request_DataReader_ptr _duplicate (Sample_Wait_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_GetResult_Request_& instance) = 0;

            protected:
                Sample_Wait_GetResult_Request_DataReader () {};
                ~Sample_Wait_GetResult_Request_DataReader () {};
            private:
                Sample_Wait_GetResult_Request_DataReader (const Sample_Wait_GetResult_Request_DataReader &);
                Sample_Wait_GetResult_Request_DataReader & operator = (const Sample_Wait_GetResult_Request_DataReader &);
            };

            class  Sample_Wait_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Wait_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Request_DataReaderView_var _var_type;

                static Sample_Wait_GetResult_Request_DataReaderView_ptr _duplicate (Sample_Wait_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_GetResult_Request_& instance) = 0;

            protected:
                Sample_Wait_GetResult_Request_DataReaderView () {};
                ~Sample_Wait_GetResult_Request_DataReaderView () {};
            private:
                Sample_Wait_GetResult_Request_DataReaderView (const Sample_Wait_GetResult_Request_DataReaderView &);
                Sample_Wait_GetResult_Request_DataReaderView & operator = (const Sample_Wait_GetResult_Request_DataReaderView &);
            };
            class Sample_Wait_GetResult_Response_TypeSupportInterface;

            typedef Sample_Wait_GetResult_Response_TypeSupportInterface * Sample_Wait_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Response_TypeSupportInterface> Sample_Wait_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Response_TypeSupportInterface> Sample_Wait_GetResult_Response_TypeSupportInterface_out;


            class Sample_Wait_GetResult_Response_DataWriter;

            typedef Sample_Wait_GetResult_Response_DataWriter * Sample_Wait_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Response_DataWriter> Sample_Wait_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Response_DataWriter> Sample_Wait_GetResult_Response_DataWriter_out;


            class Sample_Wait_GetResult_Response_DataReader;

            typedef Sample_Wait_GetResult_Response_DataReader * Sample_Wait_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Response_DataReader> Sample_Wait_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Response_DataReader> Sample_Wait_GetResult_Response_DataReader_out;


            class Sample_Wait_GetResult_Response_DataReaderView;

            typedef Sample_Wait_GetResult_Response_DataReaderView * Sample_Wait_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Wait_GetResult_Response_DataReaderView> Sample_Wait_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Wait_GetResult_Response_DataReaderView> Sample_Wait_GetResult_Response_DataReaderView_out;

            struct Sample_Wait_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Wait_GetResult_Response_, struct Sample_Wait_GetResult_Response_Seq_uniq_> Sample_Wait_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Wait_GetResult_Response_Seq> Sample_Wait_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Wait_GetResult_Response_Seq> Sample_Wait_GetResult_Response_Seq_out;

            class  Sample_Wait_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Wait_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_Wait_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_Wait_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Wait_GetResult_Response_TypeSupportInterface () {};
                ~Sample_Wait_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_Wait_GetResult_Response_TypeSupportInterface (const Sample_Wait_GetResult_Response_TypeSupportInterface &);
                Sample_Wait_GetResult_Response_TypeSupportInterface & operator = (const Sample_Wait_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_Wait_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Wait_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Response_DataWriter_var _var_type;

                static Sample_Wait_GetResult_Response_DataWriter_ptr _duplicate (Sample_Wait_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Wait_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Wait_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Wait_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_Wait_GetResult_Response_DataWriter () {};
                ~Sample_Wait_GetResult_Response_DataWriter () {};
            private:
                Sample_Wait_GetResult_Response_DataWriter (const Sample_Wait_GetResult_Response_DataWriter &);
                Sample_Wait_GetResult_Response_DataWriter & operator = (const Sample_Wait_GetResult_Response_DataWriter &);
            };

            class  Sample_Wait_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Wait_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Response_DataReader_var _var_type;

                static Sample_Wait_GetResult_Response_DataReader_ptr _duplicate (Sample_Wait_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_GetResult_Response_& instance) = 0;

            protected:
                Sample_Wait_GetResult_Response_DataReader () {};
                ~Sample_Wait_GetResult_Response_DataReader () {};
            private:
                Sample_Wait_GetResult_Response_DataReader (const Sample_Wait_GetResult_Response_DataReader &);
                Sample_Wait_GetResult_Response_DataReader & operator = (const Sample_Wait_GetResult_Response_DataReader &);
            };

            class  Sample_Wait_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Wait_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Wait_GetResult_Response_DataReaderView_var _var_type;

                static Sample_Wait_GetResult_Response_DataReaderView_ptr _duplicate (Sample_Wait_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Wait_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Wait_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Wait_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Wait_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Wait_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Wait_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Wait_GetResult_Response_& instance) = 0;

            protected:
                Sample_Wait_GetResult_Response_DataReaderView () {};
                ~Sample_Wait_GetResult_Response_DataReaderView () {};
            private:
                Sample_Wait_GetResult_Response_DataReaderView (const Sample_Wait_GetResult_Response_DataReaderView &);
                Sample_Wait_GetResult_Response_DataReaderView & operator = (const Sample_Wait_GetResult_Response_DataReaderView &);
            };
            class Wait_Feedback_TypeSupportInterface;

            typedef Wait_Feedback_TypeSupportInterface * Wait_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_Feedback_TypeSupportInterface> Wait_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_Feedback_TypeSupportInterface> Wait_Feedback_TypeSupportInterface_out;


            class Wait_Feedback_DataWriter;

            typedef Wait_Feedback_DataWriter * Wait_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_Feedback_DataWriter> Wait_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_Feedback_DataWriter> Wait_Feedback_DataWriter_out;


            class Wait_Feedback_DataReader;

            typedef Wait_Feedback_DataReader * Wait_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_Feedback_DataReader> Wait_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_Feedback_DataReader> Wait_Feedback_DataReader_out;


            class Wait_Feedback_DataReaderView;

            typedef Wait_Feedback_DataReaderView * Wait_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_Feedback_DataReaderView> Wait_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_Feedback_DataReaderView> Wait_Feedback_DataReaderView_out;

            struct Wait_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_Feedback_, struct Wait_Feedback_Seq_uniq_> Wait_Feedback_Seq;
            typedef DDS_DCPSSequence_var < Wait_Feedback_Seq> Wait_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_Feedback_Seq> Wait_Feedback_Seq_out;

            class  Wait_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_Feedback_TypeSupportInterface_var _var_type;

                static Wait_Feedback_TypeSupportInterface_ptr _duplicate (Wait_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_Feedback_TypeSupportInterface () {};
                ~Wait_Feedback_TypeSupportInterface () {};
            private:
                Wait_Feedback_TypeSupportInterface (const Wait_Feedback_TypeSupportInterface &);
                Wait_Feedback_TypeSupportInterface & operator = (const Wait_Feedback_TypeSupportInterface &);
            };

            class  Wait_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_Feedback_DataWriter_ptr _ptr_type;
                typedef Wait_Feedback_DataWriter_var _var_type;

                static Wait_Feedback_DataWriter_ptr _duplicate (Wait_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Feedback_& instance_data) = 0;

            protected:
                Wait_Feedback_DataWriter () {};
                ~Wait_Feedback_DataWriter () {};
            private:
                Wait_Feedback_DataWriter (const Wait_Feedback_DataWriter &);
                Wait_Feedback_DataWriter & operator = (const Wait_Feedback_DataWriter &);
            };

            class  Wait_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_Feedback_DataReader_ptr _ptr_type;
                typedef Wait_Feedback_DataReader_var _var_type;

                static Wait_Feedback_DataReader_ptr _duplicate (Wait_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Feedback_& instance) = 0;

            protected:
                Wait_Feedback_DataReader () {};
                ~Wait_Feedback_DataReader () {};
            private:
                Wait_Feedback_DataReader (const Wait_Feedback_DataReader &);
                Wait_Feedback_DataReader & operator = (const Wait_Feedback_DataReader &);
            };

            class  Wait_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_Feedback_DataReaderView_ptr _ptr_type;
                typedef Wait_Feedback_DataReaderView_var _var_type;

                static Wait_Feedback_DataReaderView_ptr _duplicate (Wait_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_Feedback_& instance) = 0;

            protected:
                Wait_Feedback_DataReaderView () {};
                ~Wait_Feedback_DataReaderView () {};
            private:
                Wait_Feedback_DataReaderView (const Wait_Feedback_DataReaderView &);
                Wait_Feedback_DataReaderView & operator = (const Wait_Feedback_DataReaderView &);
            };
            class Wait_FeedbackMessage_TypeSupportInterface;

            typedef Wait_FeedbackMessage_TypeSupportInterface * Wait_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Wait_FeedbackMessage_TypeSupportInterface> Wait_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Wait_FeedbackMessage_TypeSupportInterface> Wait_FeedbackMessage_TypeSupportInterface_out;


            class Wait_FeedbackMessage_DataWriter;

            typedef Wait_FeedbackMessage_DataWriter * Wait_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Wait_FeedbackMessage_DataWriter> Wait_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < Wait_FeedbackMessage_DataWriter> Wait_FeedbackMessage_DataWriter_out;


            class Wait_FeedbackMessage_DataReader;

            typedef Wait_FeedbackMessage_DataReader * Wait_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Wait_FeedbackMessage_DataReader> Wait_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < Wait_FeedbackMessage_DataReader> Wait_FeedbackMessage_DataReader_out;


            class Wait_FeedbackMessage_DataReaderView;

            typedef Wait_FeedbackMessage_DataReaderView * Wait_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Wait_FeedbackMessage_DataReaderView> Wait_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Wait_FeedbackMessage_DataReaderView> Wait_FeedbackMessage_DataReaderView_out;

            struct Wait_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Wait_FeedbackMessage_, struct Wait_FeedbackMessage_Seq_uniq_> Wait_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < Wait_FeedbackMessage_Seq> Wait_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < Wait_FeedbackMessage_Seq> Wait_FeedbackMessage_Seq_out;

            class  Wait_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Wait_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef Wait_FeedbackMessage_TypeSupportInterface_var _var_type;

                static Wait_FeedbackMessage_TypeSupportInterface_ptr _duplicate (Wait_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Wait_FeedbackMessage_TypeSupportInterface () {};
                ~Wait_FeedbackMessage_TypeSupportInterface () {};
            private:
                Wait_FeedbackMessage_TypeSupportInterface (const Wait_FeedbackMessage_TypeSupportInterface &);
                Wait_FeedbackMessage_TypeSupportInterface & operator = (const Wait_FeedbackMessage_TypeSupportInterface &);
            };

            class  Wait_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Wait_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef Wait_FeedbackMessage_DataWriter_var _var_type;

                static Wait_FeedbackMessage_DataWriter_ptr _duplicate (Wait_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Wait_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Wait_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Wait_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Wait_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_FeedbackMessage_& instance_data) = 0;

            protected:
                Wait_FeedbackMessage_DataWriter () {};
                ~Wait_FeedbackMessage_DataWriter () {};
            private:
                Wait_FeedbackMessage_DataWriter (const Wait_FeedbackMessage_DataWriter &);
                Wait_FeedbackMessage_DataWriter & operator = (const Wait_FeedbackMessage_DataWriter &);
            };

            class  Wait_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Wait_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef Wait_FeedbackMessage_DataReader_var _var_type;

                static Wait_FeedbackMessage_DataReader_ptr _duplicate (Wait_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_FeedbackMessage_& instance) = 0;

            protected:
                Wait_FeedbackMessage_DataReader () {};
                ~Wait_FeedbackMessage_DataReader () {};
            private:
                Wait_FeedbackMessage_DataReader (const Wait_FeedbackMessage_DataReader &);
                Wait_FeedbackMessage_DataReader & operator = (const Wait_FeedbackMessage_DataReader &);
            };

            class  Wait_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Wait_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef Wait_FeedbackMessage_DataReaderView_var _var_type;

                static Wait_FeedbackMessage_DataReaderView_ptr _duplicate (Wait_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Wait_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Wait_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Wait_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Wait_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Wait_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Wait_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Wait_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Wait_FeedbackMessage_& instance) = 0;

            protected:
                Wait_FeedbackMessage_DataReaderView () {};
                ~Wait_FeedbackMessage_DataReaderView () {};
            private:
                Wait_FeedbackMessage_DataReaderView (const Wait_FeedbackMessage_DataReaderView &);
                Wait_FeedbackMessage_DataReaderView & operator = (const Wait_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
