#ifndef _H_F8EED38DBA1ABC185A3325FD2B197E75_ManageLifecycleNodes__H_
#define _H_F8EED38DBA1ABC185A3325FD2B197E75_ManageLifecycleNodes__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace nav2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            namespace ManageLifecycleNodes_Request_Constants
            {
                const ::DDS::Octet STARTUP_ = 0;

                const ::DDS::Octet PAUSE_ = 1;

                const ::DDS::Octet RESUME_ = 2;

                const ::DDS::Octet RESET_ = 3;

                const ::DDS::Octet SHUTDOWN_ = 4;

            }

            struct  ManageLifecycleNodes_Request_
            {
                ::DDS::Octet command_;
            };

            typedef DDS_DCPSStruct_var<ManageLifecycleNodes_Request_> ManageLifecycleNodes_Request__var;
            typedef ManageLifecycleNodes_Request_& ManageLifecycleNodes_Request__out;

            struct  ManageLifecycleNodes_Response_
            {
                ::DDS::Boolean success_;
            };

            typedef DDS_DCPSStruct_var<ManageLifecycleNodes_Response_> ManageLifecycleNodes_Response__var;
            typedef ManageLifecycleNodes_Response_& ManageLifecycleNodes_Response__out;

            struct  Sample_ManageLifecycleNodes_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::srv::dds_::ManageLifecycleNodes_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ManageLifecycleNodes_Request_> Sample_ManageLifecycleNodes_Request__var;
            typedef Sample_ManageLifecycleNodes_Request_& Sample_ManageLifecycleNodes_Request__out;

            struct  Sample_ManageLifecycleNodes_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::nav2_msgs::srv::dds_::ManageLifecycleNodes_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ManageLifecycleNodes_Response_> Sample_ManageLifecycleNodes_Response__var;
            typedef Sample_ManageLifecycleNodes_Response_& Sample_ManageLifecycleNodes_Response__out;

        }

    }

}

#endif /* _H_F8EED38DBA1ABC185A3325FD2B197E75_ManageLifecycleNodes__H_ */
